<template>
    <div>
      <div class="gva-search-box">
        <el-form ref="searchForm" :inline="true" :model="searchInfo">
          <el-form-item label="游戏id">
            <el-input v-model="searchInfo.game_id" placeholder="游戏id" />
          </el-form-item>
          <el-form-item label="日期" prop="create_date">
           <el-date-picker
            v-model="searchInfo.create_date"
            popper-class="picker-popovers"
            class="timefilter"
            type="datetime"
            placeholder="选择日期时间"
            value-format="YYYY-MM-DD"
          >
          </el-date-picker>
          </el-form-item>
          <el-form-item>
            <el-button size="small" type="primary" icon="search" @click="onSubmit">查询</el-button>
            <el-button size="small" icon="refresh" @click="onReset">重置</el-button>
          </el-form-item>
        </el-form>
      </div>
      <div class="gva-table-box">
        <el-table :data="tableData" :span-method="objectSpanMethod" @sort-change="sortChange" @selection-change="handleSelectionChange" height="500" style="width: 100%">
          <el-table-column fixed="left" align="left" label="游戏id" min-width="90" prop="game_id" sortable="custom" />
          <el-table-column fixed="left" align="left" label="任务名称" min-width="90" prop="game_name" sortable="custom" />
          <el-table-column fixed="left" align="left" label="日期" min-width="90" prop="create_date" />
          <el-table-column fixed="left" align="left" label="脚本负责人" min-width="90" prop="operator" />
          <el-table-column fixed="left" align="left" label="类型" min-width="60" prop="type" sortable="custom">
          <template #default="scope">
            <div>
              {{ typeFiletr(scope.row.type) }}
            </div>
          </template>
        </el-table-column>
      <el-table-column label="拉取账号">
        <el-table-column prop="pull_account_ok" label="成功" width="60" />
        <el-table-column prop="pull_account_fail" label="失败" width="60" />
      </el-table-column>
      <el-table-column label="启动代理">
        <el-table-column prop="start_proxy_ok" label="成功" width="60" />
        <el-table-column prop="start_proxy_fail" label="失败" width="60" />
      </el-table-column>
      <el-table-column label="模拟器启动">
        <el-table-column prop="simulator_start_ok" label="成功" width="60" />
        <el-table-column prop="start_proxy_fail" label="失败" width="60" />
      </el-table-column>
      <el-table-column label="网络检查">
        <el-table-column prop="network_check_ok" label="成功" width="60" />
        <el-table-column prop="network_check_fail" label="失败" width="60" />
      </el-table-column>
      <el-table-column label="启动游戏">
        <el-table-column prop="enter_start_game" label="进入" width="60" />
        <el-table-column prop="game_start_ok" label="成功" width="60" />
        <el-table-column prop="game_start_fail" label="失败" width="60" />
        
      </el-table-column>
      <el-table-column label="登录游戏">
        <el-table-column prop="enter_login" label="进入" width="60" />
        <el-table-column prop="login_ok" label="成功" width="60" />
        <el-table-column prop="login_fail" label="失败" width="60" />
      </el-table-column>
      <el-table-column label="微信授权">
        <el-table-column prop="enter_scanning_code" label="进入" width="60" />
        <el-table-column prop="scanning_code_success" label="成功" width="60" />
        <el-table-column prop="transcoding_fail" label="转码失败" width="60" />
        <el-table-column prop="third_party_fail" label="三方失败" width="60" />
      </el-table-column>
      <el-table-column label="实名认证">
        <el-table-column prop="enter_authentication" label="进入" width="60" />
        <el-table-column prop="authentication_ok" label="成功" width="60" />
        <el-table-column prop="authentication_fail" label="失败" width="60" />
      </el-table-column>
      <el-table-column label="选区">
        <el-table-column prop="enter_constituency" label="进入" width="60" />
        <el-table-column prop="constituency_ok" label="成功" width="60" />
        <el-table-column prop="constituency_fail" label="失败" width="60" />
      </el-table-column>
      <el-table-column label="角色">
        <el-table-column prop="has_role" label="有" width="60" />
        <el-table-column prop="not_role" label="无" width="60" />
      </el-table-column>
      <el-table-column label="进入游戏">
        <el-table-column prop="enter_game" label="进入" width="60" />
        <el-table-column prop="enter_game_ok" label="成功" width="60" />
        <el-table-column prop="enter_game_fail" label="失败" width="60" />
      </el-table-column>
      <el-table-column label="主线教程">
        <el-table-column prop="enter_main" label="进入" width="60" />
        <el-table-column prop="enter_main_ok" label="成功" width="60" />
        <el-table-column prop="enter_main_fail" label="失败" width="60" />
      </el-table-column>
      <el-table-column label="付费">
        <el-table-column prop="enter_fee" label="进入" width="60" />
        <el-table-column prop="fee_ok" label="成功" width="60" />
        <el-table-column prop="fee_fail" label="失败" width="60" />
      </el-table-column>
      <el-table-column label="封号" min-width="60" prop="ban_off" />
      <el-table-column label="冻结" min-width="60" prop="freeze" />
        </el-table>
        <div class="gva-pagination">
          <el-pagination
            :current-page="page"
            :page-size="pageSize"
            :page-sizes="[10, 30, 50, 100]"
            :total="total"
            layout="total, sizes, prev, pager, next, jumper"
            @current-change="handleCurrentChange"
            @size-change="handleSizeChange"
          />
        </div>
  
      </div>
  
      <el-dialog v-model="dialogFormVisible" :before-close="closeDialog" :title="dialogTitle">
        <el-table :data="tableData" @sort-change="sortChange" @selection-change="handleSelectionChange" height="500" style="width: 100%">
          <el-table-column
            type="selection"
            width="55"
          />
          <el-table-column fixed="left" align="left" label="游戏id" min-width="90" prop="game_id" sortable="custom" />
          <el-table-column fixed="left" align="left" label="日期" min-width="90" prop="create_date" />
          <el-table-column fixed="left" align="left" label="脚本负责人" min-width="90" prop="operator" />
          </el-table>
      </el-dialog>
    </div>
  </template>
  
  <script>
  export default {
    name: 'LogNodeStatisticsList',
  }
  </script>
  
  <script setup>
  import {
    logNodeStatistics,
  } from '@/api/log'
  import { toSQLLine } from '@/utils/stringFun'
  import { ref } from 'vue'
  import { ElMessage, ElMessageBox } from 'element-plus'
  import warningBar from '@/components/warningBar/warningBar.vue'
  
  const apis = ref([])
  const form = ref({
      game_name: '',
      game_package_name: ''
  })
  
  
  const type = ref('')
  const rules = ref({
    game_name: [{ required: true, message: '请输入游戏名称', trigger: 'blur' }],
    game_package_name: [
      { required: true, message: '请输入游戏包名', trigger: 'blur' }
    ]
  })
  
  const page = ref(1)
  const total = ref(0)
  const pageSize = ref(10)
  const tableData = ref([])
  const tableFailData = ref([])
  const searchInfo = ref({})
  
  const onReset = () => {
    searchInfo.value = {}
  }
  // 搜索
  
  const onSubmit = () => {
    page.value = 1
    pageSize.value = 10
    searchInfo.value.game_id = Number(searchInfo.value.game_id)
    searchInfo.value.coding = Number(searchInfo.value.coding)
    getTableData()
  }

  const searchFailData = (gameid) => {
    //form.value.parent_id = String(id)
    getTableFailData
    dialogFormVisible.value = true
  }

  // 查询
  const getTableFailData = async() => {
    const table = await logNodeStatistics({ page: page.value, pageSize: pageSize.value, ...searchInfo.value })
    if (table.code === 0) {
      tableData.value = table.data
    }
  }

  const typeFiletr = (value) => {
  const target = typeOptions.value.filter(item => item.value === value)[0]
  return target && `${target.label}`
}
  
  const typeOptions = ref([
  {
    value: 0,
    label: '新增',
    type: ''
  },
  {
    value: 1,
    label: '活跃',
    type: ''
  }
])

  // 分页
  const handleSizeChange = (val) => {
    pageSize.value = val
    getTableData()
  }
  
  const handleCurrentChange = (val) => {
    page.value = val
    getTableData()
  }
  
  // 排序
  const sortChange = ({ prop, order }) => {
    if (prop) {
      if (prop === 'id') {
        prop = 'id'
      }
      searchInfo.value.orderKey = toSQLLine(prop)
      searchInfo.value.desc = order === 'descending'
    }
    getTableData()
  }
  
  // 查询
  const getTableData = async() => {
    const table = await logNodeStatistics({ page: page.value, pageSize: pageSize.value, ...searchInfo.value })
    if (table.code === 0) {
      tableData.value = table.data.list
      total.value = table.data.total
      page.value = table.data.page
      pageSize.value = table.data.pageSize
      getSpanArr(table.data.list)
    }
  }
  
  getTableData()
  
  // 批量操作
  const handleSelectionChange = (val) => {
    apis.value = val
  }
  
  const deleteVisible = ref(false)
  
  
  // 弹窗相关
  const apiForm = ref(null)
  const initForm = () => {
    apiForm.value.resetFields()
    form.value = {
      game_name: '',
      game_package_name: ''
    }
  }
  
  const dialogTitle = ref('新增game')
  const dialogFormVisible = ref(false)
  const openDialog = (key) => {
    switch (key) {
      case 'addGame':
        dialogTitle.value = '新增game'
        break
      case 'edit':
        dialogTitle.value = '编辑game'
        break
      default:
        break
    }
    type.value = key
    dialogFormVisible.value = true
  }
  const closeDialog = () => {
    dialogFormVisible.value = false
  }
  
  const editCardFunc = async(row) => {
    const res = await getGameById({ id: row.id })
    form.value = res.data
    openDialog('edit')
  }
  
  const enterDialog = async() => {
    apiForm.value.validate(async valid => {
      if (valid) {
        switch (type.value) {
          case 'addGame':
            {
              const res = await cuGame(form.value)
              if (res.code === 0) {
                ElMessage({
                  type: 'success',
                  message: '添加成功',
                  showClose: true
                })
              }
              getTableData()
              closeDialog()
            }
  
            break
          case 'edit':
            {
              const res = await cuGame(form.value)
              if (res.code === 0) {
                ElMessage({
                  type: 'success',
                  message: '编辑成功',
                  showClose: true
                })
              }
              getTableData()
              closeDialog()
            }
            break
          default:
            // eslint-disable-next-line no-lone-blocks
            {
              ElMessage({
                type: 'error',
                message: '未知操作',
                showClose: true
              })
            }
            break
        }
      }
    })
  }

  let spanArr = []
  const getSpanArr = (data) => {
    spanArr = []
    var pos = 0
    for (var i = 0; i < data.length; i++) {
          if (i === 0) {
            spanArr.push(1);
            pos = 0
          } else {
            if (data[i].game_id === data[i - 1].game_id) {
              spanArr[pos] += 1;
              spanArr.push(0);
            } else {
              spanArr.push(1);
              pos = i;
            }
          }
        }
        console.log(spanArr)  
  }

  const objectSpanMethod = (row) => {
    if (row.columnIndex === 0 || row.columnIndex === 3 ||  row.columnIndex === 2 ||  row.columnIndex === 1) {
          const rowspan = spanArr[row.rowIndex];
          const colspan = rowspan > 0 ? 1 : 0;
          return {
            rowspan: rowspan,
            colspan: colspan
          }
        }
  }
  
  
  </script>
  
  <style scoped lang="scss">
  .button-box {
    padding: 10px 20px;
    .el-button {
      float: right;
    }
  }
  .warning {
    color: #dc143c;
  }
  </style>
  